%global distro  OpenCloudOS Stream
%global major   23

Summary:        %{distro} release files
Name:           opencloudos-stream-release
Version:        %{major}
Release:        20%{?dist}
License:        GPLv2
URL:            https://www.opencloudos.org/
Source0:        OpenCloudOS-Stream.repo
Source1:        OpenCloudOS-Stream-EPOL.repo

Source200:      EULA
Source201:      LICENSE

Source300:      90-default.preset
Source301:      99-default-disable.preset
Source302:      85-display-manager.preset
Source303:      90-default-user.preset

Source500:      50-opencloudos.conf
SOURCE600:      RPM-GPG-KEY-OpenCloudOS-Stream


BuildArch:      noarch
Requires:       opencloudos-stream-repos = %{version}-%{release}
Provides:       opencloudos-stream-release = %{version}-%{release}
Provides:       opencloudos-release = %{major}-%{release}
# Required for a lorax run (to generate install media)
Provides:       opencloudos-stream-release-eula
Provides:       opencloudos-release-eula
Provides:       system-release = %{version}-%{release}
Provides:       system-release(releasever) = %{major}

Obsoletes:      tencentos-release
Provides:       tencentos-release

%description
%{distro} release files.


%package -n opencloudos-stream-repos
Summary:        OpenCloudOS Stream package repositories
Requires:       opencloudos-stream-release = %{version}-%{release}

%description -n opencloudos-stream-repos
This package provides the package repository files for OpenCloudOS Stream.

%package -n opencloudos-stream-epol-repos
Summary:        Extra Packages for OpenCloudOS Linux(EPOL) repository file.
Requires:       opencloudos-stream-release = %{version}-%{release}
Provides:       epol-release = %{version}-%{release}

%description -n opencloudos-stream-epol-repos
This package provides the repository file of Extra Packages for OpenCloudOS Linux(EPOL).

%install
mkdir -p ./docs
cp %{SOURCE201} ./docs

# create /etc/system-release and /etc/opencloudos-release
install -d -m 0755 %{buildroot}%{_sysconfdir}
echo "%{distro} release %{major}" > %{buildroot}%{_sysconfdir}/opencloudos-stream-release
ln -s opencloudos-stream-release %{buildroot}%{_sysconfdir}/system-release
ln -s opencloudos-stream-release %{buildroot}%{_sysconfdir}/opencloudos-release


install -d -m 0755 %{buildroot}%{_prefix}/lib
cat > %{buildroot}%{_prefix}/lib/os-release << EOF
NAME="%{distro}"
VERSION="%{major}"
ID="opencloudos"
ID_LIKE="opencloudos"
VERSION_ID="%{major}"
PLATFORM_ID="platform:ocs%{major}"
PRETTY_NAME="%{distro} %{major}"
ANSI_COLOR="0;31"
CPE_NAME="cpe:/o:opencloudos:opencloudos:%{major}"
HOME_URL="https://www.opencloudos.org/"
BUG_REPORT_URL="https://bugs.opencloudos.tech/"
EOF

# symlink for /etc/os-release
ln -s ../usr/lib/os-release %{buildroot}%{_sysconfdir}/os-release

# write cpe to /etc/system/release-cpe
echo "cpe:/o:opencloudos:opencloudos:%{major}" > %{buildroot}%{_sysconfdir}/system-release-cpe

# create /etc/issue, /etc/issue.net and /etc/issue.d
echo '\S' > %{buildroot}%{_sysconfdir}/issue
echo 'Kernel \r on an \m' >> %{buildroot}%{_sysconfdir}/issue
cp %{buildroot}%{_sysconfdir}/issue{,.net}
echo >> %{buildroot}%{_sysconfdir}/issue
mkdir -p %{buildroot}%{_sysconfdir}/issue.d

# set up the dist tag macros
mkdir -p %{buildroot}%{_rpmmacrodir}
cat > %{buildroot}%{_rpmmacrodir}/macros.dist << EOF
# dist macros.

%%opencloudos 0
%%ocs %{major}
%%dist .ocs%{major}
EOF

# use unbranded datadir
install -d -m 0755 %{buildroot}%{_datadir}/opencloudos-stream-release
ln -s opencloudos-stream-release %{buildroot}%{_datadir}/opencloudos-release

install -p -m 0644 %{SOURCE200} %{buildroot}%{_datadir}/opencloudos-stream-release/

install -d -m 0755 %{buildroot}%{_prefix}/lib/systemd/system-preset/
install -d -m 0755 %{buildroot}%{_prefix}/lib/systemd/user-preset
# copy presets for both system and user
install -p -m 0644 %{SOURCE300} %{SOURCE301} %{SOURCE302} %{buildroot}%{_prefix}/lib/systemd/system-preset/
install -p -m 0644 %{SOURCE303} %{SOURCE301} %{buildroot}%{_prefix}/lib/systemd/user-preset/

mkdir -p %{buildroot}/%{_prefix}/lib/sysctl.d/
install -m 0644 %{SOURCE500} %{buildroot}/%{_prefix}/lib/sysctl.d/

# Create stub yum repos
mkdir %{buildroot}%{_sysconfdir}/yum.repos.d

# copy yum repos
install -d -m 0755 %{buildroot}%{_sysconfdir}/yum.repos.d

install -m 0644 %{SOURCE0} %{buildroot}%{_sysconfdir}/yum.repos.d/
install -m 0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/yum.repos.d/

# dnf variables
install -d -m 0755 %{buildroot}%{_sysconfdir}/dnf/vars
echo "%{major}-stream" > %{buildroot}%{_sysconfdir}/dnf/vars/stream

# copy GPG keys
install -d -m 0755 %{buildroot}%{_sysconfdir}/pki/rpm-gpg
install -p -m 0644 %{SOURCE600} %{buildroot}%{_sysconfdir}/pki/rpm-gpg/

%files
%license docs/LICENSE
%{_sysconfdir}/opencloudos-release
%{_sysconfdir}/system-release
%{_sysconfdir}/opencloudos-stream-release
%config(noreplace) %{_sysconfdir}/os-release
%config %{_sysconfdir}/system-release-cpe
%config(noreplace) %{_sysconfdir}/issue
%config(noreplace) %{_sysconfdir}/issue.net
%dir %{_sysconfdir}/issue.d
%dir %{_sysconfdir}/yum.repos.d
%{_rpmmacrodir}/macros.dist
%{_datadir}/opencloudos-release
%{_datadir}/opencloudos-stream-release
%{_prefix}/lib/os-release
%{_prefix}/lib/sysctl.d/50-opencloudos.conf
%{_prefix}/lib/systemd/system-preset/*
%{_prefix}/lib/systemd/user-preset/*
%{_sysconfdir}/pki/rpm-gpg

%files -n opencloudos-stream-repos
%config(noreplace) %{_sysconfdir}/dnf/vars/stream
%config(noreplace) %{_sysconfdir}/yum.repos.d/OpenCloudOS-Stream.repo

%files -n opencloudos-stream-epol-repos
%config(noreplace) %{_sysconfdir}/yum.repos.d/OpenCloudOS-Stream-EPOL.repo


%changelog
* Thu Jun 6 2024 Shuo Wang <abushwang@tencent.com> - 23-20
- provides epol-release for oc

* Wed May 15 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 23-19
- provide and obsolete tencentos-release

* Thu Feb 22 2024 Yi Lin <nilusyi@tencent.com> - 23-18
- enabled repo gpgcheck.

* Tue Nov 21 2023 cunshunxia <cunshunxia@tencent.com> - 23-17
- fix pipewire audio detection problem.

* Tue Nov 14 2023 cunshunxia <cunshunxia@tencent.com> - 23-16
- use pulseaudio instead of pipewire which may not work well.

* Tue Nov 14 2023 rockerzhu <rockerzhu@tencent.com> - 23-15
- Update License file.

* Tue Nov 14 2023 cunshunxia <cunshunxia@tencent.com> - 23-14
- enable pipewire for audio use.

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 23-13
- Rebuilt for OpenCloudOS Stream 23.09

* Thu May 25 2023 rockerzhu <rockerzhu@tencent.com> - 23-12
- Update license.

* Tue May 09 2023 cunshunxia <cunshunxia@tencent.com> - 23-11
- enable systemd-resolved by default.

* Tue May 09 2023 cunshunxia <cunshunxia@tencent.com> - 23-10
- enable getty@.service instead of getty@tty1.service.

* Mon May 08 2023 Yi Lin <nilusyi@tencent.com> - 23-9
- add OCS-EPOL repo.

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 23-8
- Rebuilt for OpenCloudOS Stream 23.05

* Thu Apr 20 2023 cunshunxia <cunshunxia@tencent.com> - 23-7
- disable systemd-resolved by default.

* Thu Apr 13 2023 Xiaojie Chen <jackxjchen@tencent.com> - 23-6
- Enable gdm.service by default

* Thu Apr 13 2023 Yi Lin <nilusyi@tencent.com> - 23-5
- fix bogus date.

* Thu Apr 13 2023 Yi Lin <nilusyi@tencent.com> - 23-4
- fix debuginfo name in repo file.

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 23-3
- Rebuilt for OpenCloudOS Stream 23

* Mon Feb 27 2023 Yi Lin <nilusyi@tencent.com> - 23-2
- add gpg public key.
- update repo file to BaseOS and AppStream.

* Mon Feb 27 2023 Yi Lin <nilusyi@tencent.com> - 23-1
- update version to 23, init release to 1.

* Mon Feb 27 2023 rockerzhu <rockerzhu@tencent.com> - 2301-8
- Update license.

* Mon Feb 27 2023 Yi Lin <nilusyi@tencent.com> - 2301-7
- Fix CRLF in repo file.

* Tue Dec 27 2022 Yi Lin <nilusyi@tencent.com> - 2301-6
- add enabled key in repo file.

* Fri Dec 23 2022 Yi Lin <nilusyi@tencent.com> - 2301-5
- add noreplace attr in repo file.

* Thu Dec 22 2022 Yi Lin <nilusyi@tencent.com> - 2301-4
- change repo to releasever and basearch.

* Thu Dec 22 2022 Yi Lin <nilusyi@tencent.com> - 2301-3
- mv yum repo into repos pkg.

* Thu Dec 22 2022 Yi Lin <nilusyi@tencent.com> - 2301-2
- add yum repo.

* Wed Dec 21 2022 Yi Lin <nilusyi@tencent.com> - 2301-1
- define major version to 2301.

* Wed Dec 21 2022 rockerzhu <rockerzhu@tencent.com> - 1.0-6
- disable oomd service.

* Wed Dec 21 2022 rockerzhu <rockerzhu@tencent.com> - 1.0-5
- add default startup services

* Wed Dec 14 2022 rockerzhu <rockerzhu@tencent.com> - 1.0-4
- Initial default startup services

* Wed Oct 26 2022 rockerzhu <rockerzhu@tencent.com> - 1.0-3
- Add preset for default disable

* Thu Oct 20 2022 Wang Guodong <gordonwwang@tencent.com> - 1.0-2
- Rename the macro %oc to %ocs

* Thu Aug 11 2022 Yi Lin <nilusyi@tencent.com> - 1.0-1
- Initial setup for OpenCloudOS Stream
